import argparse
import logging
import yaml

class Config:

    username = None
    password = None
    url = None
    path = None

    def parse_args(self):
        parser = argparse.ArgumentParser(description='Process some integers.')
        parser.add_argument('--path', type=str, help='Path to config yaml file', dest='path')
        args = parser.parse_args()
        return args

    def load_config(self, path=None):
        if path is None:
            path = '.config.yaml'
        confFile = yaml.safe_load(open(path))
        self.username = confFile['username']
        self.password = confFile['password']
        self.url = confFile['url']
        self.path = self.parse_args().path
        if self.path is None:
            self.path = confFile['path']
        logging.info(f"Loaded config from {path}")