import threading
import os

class Dispatcher:

    threads = []
    audioProcessor = None
    extensionFilter = None
    noteGenerator = None

    def add_audio_processor(self, audioProcessor):
        self.audioProcessor = audioProcessor

    def add_note_generator(self, noteGenerator):
        self.noteGenerator = noteGenerator
    
    def process_audio_file(self, audio_file):
        self.threads.append(threading.Thread(target=self._execute_thread, args=(audio_file,)))
        self.threads[-1].start()
        # TODO: we need to have a way to wipe old threads, otherwise we may have a memory leak

    def _execute_thread(self, audio_file):
        filename = os.path.basename(audio_file)
        note = self.audioProcessor.execute(audio_file)
        self.noteGenerator.generate_note(filename, note)

    def halt(self):
        for thread in self.threads:
            thread.join(10)